-----------------------------------------------------------------------------

local AloftCastBarOverlay = Aloft:NewModule("CastBarOverlay", "AceEvent-2.0")

-----------------------------------------------------------------------------

function AloftCastBarOverlay:UpdateAll()
	for frame in Aloft:IterateNameplates() do	
		self:SetupFrame(frame)
	end
end

-----------------------------------------------------------------------------

function AloftCastBarOverlay:OnEnable()
	self:RegisterEvent("Aloft:SetupFrame", "SetupFrame")
	self:RegisterEvent("Aloft:OnCastBarShow", "OnCastBarShow")

	self:UpdateAll()
end

function AloftCastBarOverlay:OnDisable()
	self:UnregisterAllEvents()
	
	for frame in Aloft:IterateNameplates() do
		local castBarOverlayFrame = frame.aloftData.castBarOverlayFrame

		castBarOverlayFrame:ClearAllPoints()
		castBarOverlayFrame:SetPoint("CENTER", frame, "CENTER", 0, -16)
		castBarOverlayFrame:SetTexture("Interface\\Tooltips\\Nameplate-Border")
		castBarOverlayFrame:SetTexCoord(0.0, 1.0, 1.0, 1.0)
		castBarOverlayFrame:SetAlpha(1)
		castBarOverlayFrame:SetWidth(128)
		castBarOverlayFrame:SetHeight(32)
	end
end

function AloftCastBarOverlay:SetupFrame(frame)
	local castBarOverlayFrame = select(2, frame:GetRegions())

	castBarOverlayFrame:SetAlpha(0)
	castBarOverlayFrame:Hide()

	frame.aloftData.castBarOverlayFrame = castBarOverlayFrame
end

function AloftCastBarOverlay:OnCastBarShow(frame)
	local castBarOverlayFrame = frame.aloftData.castBarOverlayFrame
	castBarOverlayFrame:SetAlpha(0)
	castBarOverlayFrame:Hide()
end

function AloftCastBarOverlay:OnCastBarValueChanged(frame)
	local castBarOverlayFrame = frame.aloftData.castBarOverlayFrame
	castBarOverlayFrame:SetAlpha(0)
	castBarOverlayFrame:Hide()
end

-----------------------------------------------------------------------------
