-----------------------------------------------------------------------------

local AloftOverlay = Aloft:NewModule("Overlay", "AceEvent-2.0")

-----------------------------------------------------------------------------

function AloftOverlay:UpdateAll()
	for frame in Aloft:IterateNameplates() do	
		self:SetupFrame(frame)
	end
end

-----------------------------------------------------------------------------

function AloftOverlay:OnEnable()
	self:RegisterEvent("Aloft:SetupFrame", "SetupFrame")
	self:UpdateAll()
end

function AloftOverlay:OnDisable()
	self:UnregisterAllEvents()

	for frame in Aloft:IterateNameplates() do
		local overlayFrame = frame:GetRegions()
		overlayFrame:ClearAllPoints()
		overlayFrame:SetPoint("TOPLEFT", frame, "TOPLEFT")
		overlayFrame:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT")
		overlayFrame:SetTexture("Interface\\Tooltips\\Nameplate-Border")
		overlayFrame:SetVertexColor(1.0, 1.0, 1.0, 1.0)
		overlayFrame:SetTexCoord(0.0, 1.0, 0.0, 1.0)
		overlayFrame:Show()
	end
end

function AloftOverlay:SetupFrame(frame)
	local overlayFrame = frame:GetRegions()
	overlayFrame:Hide()
end

-----------------------------------------------------------------------------
